--- CORE-14961-before.txt	2018-08-24 19:25:32.000000000 +0900
+++ CORE-14961-after.txt	2018-08-24 20:19:30.000000000 +0900
@@ -1,43 +1,46 @@
 CShellLink.cpp:150: Test failed: IShellLink::GetPath(2), flags 0x1, in %anyvar%%comspec%, got C:\ReactOS\bin\%anyvar%C:\ReactOS\system32\cmd.exe, expected c:\%anyvar%C:\ReactOS\system32\cmd.exe
 CShellLink.cpp:309: Test failed: IExtractIcon::GetIconLocation(0) returned hr = 0x0, expected 0x1
-CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(0) returned wFlags = 0xdeadbeef, expected 0xa
-CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(0) returned '', expected 'C:\ReactOS\system32\cmd.exe'
+CShellLink.cpp:310: Test failed: IExtractIcon::GetIconLocation(0) returned 'C:\ReactOS\system32\cmd.exe'
+CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(0) returned wFlags = 0x0, expected 0xa
 CShellLink.cpp:352: Test failed: IShellLink::GetIconLocation(0) returned 'C:\ReactOS\explorer.exe', expected '%SystemRoot%\explorer.exe'
 CShellLink.cpp:362: Test failed: IExtractIcon::GetIconLocation(0) returned hr = 0x0, expected 0x1
 CShellLink.cpp:363: Test failed: IExtractIcon::GetIconLocation(0) returned 'C:\ReactOS\explorer.exe'
 CShellLink.cpp:376: Test failed: IExtractIcon::GetIconLocation(0) returned wFlags = 0xdeadbeef, expected 0xa
 CShellLink.cpp:382: Test failed: IExtractIcon::GetIconLocation(0) returned 'C:\ReactOS\explorer.exe', expected 'C:\ReactOS\system32\cmd.exe'
 CShellLink.cpp:309: Test failed: IExtractIcon::GetIconLocation(1) returned hr = 0x0, expected 0x1
-CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(1) returned wFlags = 0xdeadbeef, expected 0xa
-CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(1) returned '', expected 'C:\ReactOS\system32\autochk.exe'
+CShellLink.cpp:310: Test failed: IExtractIcon::GetIconLocation(1) returned 'C:\ReactOS\system32\autochk.exe'
+CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(1) returned wFlags = 0x0, expected 0xa
 CShellLink.cpp:352: Test failed: IShellLink::GetIconLocation(1) returned 'C:\ReactOS\explorer.exe', expected '%SystemRoot%\explorer.exe'
 CShellLink.cpp:362: Test failed: IExtractIcon::GetIconLocation(1) returned hr = 0x0, expected 0x1
 CShellLink.cpp:363: Test failed: IExtractIcon::GetIconLocation(1) returned 'C:\ReactOS\explorer.exe'
 CShellLink.cpp:376: Test failed: IExtractIcon::GetIconLocation(1) returned wFlags = 0xdeadbeef, expected 0xa
 CShellLink.cpp:382: Test failed: IExtractIcon::GetIconLocation(1) returned 'C:\ReactOS\explorer.exe', expected 'C:\ReactOS\system32\autochk.exe'
 CShellLink.cpp:309: Test failed: IExtractIcon::GetIconLocation(2) returned hr = 0x0, expected 0x1
-CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(2) returned wFlags = 0xdeadbeef, expected 0xc
-CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(2) returned '', expected '*'
+CShellLink.cpp:310: Test failed: IExtractIcon::GetIconLocation(2) returned 'C:\ReactOS\system32\shell32.dll'
+CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(2) returned wFlags = 0x0, expected 0xc
+CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(2) returned 'C:\ReactOS\system32\shell32.dll', expected '*'
 CShellLink.cpp:352: Test failed: IShellLink::GetIconLocation(2) returned 'C:\ReactOS\explorer.exe', expected '%SystemRoot%\explorer.exe'
 CShellLink.cpp:362: Test failed: IExtractIcon::GetIconLocation(2) returned hr = 0x0, expected 0x1
 CShellLink.cpp:363: Test failed: IExtractIcon::GetIconLocation(2) returned 'C:\ReactOS\explorer.exe'
 CShellLink.cpp:376: Test failed: IExtractIcon::GetIconLocation(2) returned wFlags = 0xdeadbeef, expected 0xc
 CShellLink.cpp:382: Test failed: IExtractIcon::GetIconLocation(2) returned 'C:\ReactOS\explorer.exe', expected '*'
 CShellLink.cpp:309: Test failed: IExtractIcon::GetIconLocation(3) returned hr = 0x0, expected 0x1
-CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(3) returned wFlags = 0xdeadbeef, expected 0xc
-CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(3) returned '', expected '*'
+CShellLink.cpp:310: Test failed: IExtractIcon::GetIconLocation(3) returned 'C:\ReactOS\system32\shell32.dll'
+CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(3) returned wFlags = 0x0, expected 0xc
+CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(3) returned 'C:\ReactOS\system32\shell32.dll', expected '*'
 CShellLink.cpp:352: Test failed: IShellLink::GetIconLocation(3) returned 'C:\ReactOS\explorer.exe', expected '%SystemRoot%\explorer.exe'
 CShellLink.cpp:362: Test failed: IExtractIcon::GetIconLocation(3) returned hr = 0x0, expected 0x1
 CShellLink.cpp:363: Test failed: IExtractIcon::GetIconLocation(3) returned 'C:\ReactOS\explorer.exe'
 CShellLink.cpp:376: Test failed: IExtractIcon::GetIconLocation(3) returned wFlags = 0xdeadbeef, expected 0xc
 CShellLink.cpp:382: Test failed: IExtractIcon::GetIconLocation(3) returned 'C:\ReactOS\explorer.exe', expected '*'
 CShellLink.cpp:309: Test failed: IExtractIcon::GetIconLocation(4) returned hr = 0x0, expected 0x1
-CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(4) returned wFlags = 0xdeadbeef, expected 0xc
-CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(4) returned '', expected '*'
+CShellLink.cpp:310: Test failed: IExtractIcon::GetIconLocation(4) returned 'C:\ReactOS\system32\shell32.dll'
+CShellLink.cpp:323: Test failed: IExtractIcon::GetIconLocation(4) returned wFlags = 0x0, expected 0xc
+CShellLink.cpp:329: Test failed: IExtractIcon::GetIconLocation(4) returned 'C:\ReactOS\system32\shell32.dll', expected '*'
 CShellLink.cpp:352: Test failed: IShellLink::GetIconLocation(4) returned 'C:\ReactOS\explorer.exe', expected '%SystemRoot%\explorer.exe'
 CShellLink.cpp:362: Test failed: IExtractIcon::GetIconLocation(4) returned hr = 0x0, expected 0x1
 CShellLink.cpp:363: Test failed: IExtractIcon::GetIconLocation(4) returned 'C:\ReactOS\explorer.exe'
 CShellLink.cpp:376: Test failed: IExtractIcon::GetIconLocation(4) returned wFlags = 0xdeadbeef, expected 0xc
 CShellLink.cpp:382: Test failed: IExtractIcon::GetIconLocation(4) returned 'C:\ReactOS\explorer.exe', expected '*'
 
-CShellLink: 189 tests executed (0 marked as todo, 41 failures), 0 skipped.
+CShellLink: 189 tests executed (0 marked as todo, 44 failures), 0 skipped.